#include <time.h>
#include <unistd.h>
#include <stdio.h>

#include "8080.h"
#include "io.h"
#include "mainloop.h"

#define Xsleep(T) (usleep((T)/1000))

double speed = 0; /* Speed in MHz, 0 = as fast as possible */
double refresh_rate = 60; /* Refresh rate in Hz */
long long nanosecs_per_iteration;
long cycles_per_iteration;

struct timespec tp;

unsigned long long cur_time();

unsigned long long cur_time() {
	clock_gettime(CLOCK_REALTIME, &tp);
	return (tp.tv_sec) * 1000000000 + (tp.tv_nsec);
}

int mainloop(word start, double speed) {
	unsigned long long counter = cur_time();
	unsigned long long current_clock;

	int quit_signal = 0;

	nanosecs_per_iteration = 1000000000 / refresh_rate;
	cycles_per_iteration = ((speed * 1000000) / refresh_rate);

	init_emulator(start);

	while(!quit_signal) {
		counter += nanosecs_per_iteration;
		quit_signal = run_emulator(cycles_per_iteration);
		if(getctrlz()) {
			quit_signal = 1;
		}
		if(counter > (current_clock = cur_time())) {
			Xsleep(counter - current_clock);
		} else if(!quit_signal) {
			counter = cur_time(); /* Running too slow... */
		}
	}
	return quit_signal;
}

