#include "term.h"

#include <stdio.h>
#include <string.h>
#include <termios.h>

struct termios orig_term_attr;
struct termios orig_term_attr_out;
struct termios new_term_attr;

void setcterm(int i) {
	new_term_attr.c_cc[VMIN] = i;
	tcsetattr(fileno(stdin), TCSANOW, &new_term_attr);
}

void setterm(void) {
  	tcgetattr(fileno(stdin), &orig_term_attr);
	tcgetattr(fileno(stdout), &orig_term_attr_out);
	memcpy(&new_term_attr, &orig_term_attr, sizeof(struct termios));

	new_term_attr.c_lflag &= ~(ECHO | BRKINT | ICRNL
		| INPCK | ISTRIP | IXON | ISIG);
	new_term_attr.c_oflag &= ~(OPOST);
	new_term_attr.c_cflag |= (CS8);
	new_term_attr.c_iflag &= ~(ECHO | ICANON | IEXTEN);
	new_term_attr.c_cc[VMIN] = 0;
	new_term_attr.c_cc[VTIME] = 0;

	tcsetattr(fileno(stdin), TCSANOW, &new_term_attr);
}

void resetterm(void) {
  	tcsetattr(fileno(stdin), TCSANOW, &orig_term_attr);
	tcsetattr(fileno(stdout), TCSANOW, &orig_term_attr_out);
}
